using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

namespace UI
{
	/// <summary>
	/// Description rsume de frmTimerDisplay.
	/// </summary>
	public class frmTimerDisplay : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Label lblTimer;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Timer tmrSeconds;

		private frmEveTimer m_instance;
		private int m_minutes;
		private int m_seconds;
		private Color m_highlightColor;
		private System.Windows.Forms.Button btnReset;
        private Color m_fontColor;
        private MenuItem mniReset;
        private MenuItem mniStop;
        private ContextMenu ctxMenuTimer;
        private MenuItem menuItem1;
        private MenuItem menuItemConfirmReset;
        private MenuItem menuItem2;
		private bool m_isResizable = false;

		public frmTimerDisplay(frmEveTimer instance)
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//		
			
			m_instance = instance;
			this.TopMost = true;

			// Sauvegarde couleurs
			m_fontColor = instance.m_fontColor;
			m_highlightColor = instance.m_blinkColor;	// Couleur clignotement
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmTimerDisplay));
            this.btnStop = new System.Windows.Forms.Button();
            this.lblTimer = new System.Windows.Forms.Label();
            this.tmrSeconds = new System.Windows.Forms.Timer(this.components);
            this.btnReset = new System.Windows.Forms.Button();
            this.mniReset = new System.Windows.Forms.MenuItem();
            this.mniStop = new System.Windows.Forms.MenuItem();
            this.ctxMenuTimer = new System.Windows.Forms.ContextMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItemConfirmReset = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.SuspendLayout();
            // 
            // btnStop
            // 
            this.btnStop.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.btnStop.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnStop.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnStop.Location = new System.Drawing.Point(0, 104);
            this.btnStop.Name = "btnStop";
            this.btnStop.Size = new System.Drawing.Size(184, 24);
            this.btnStop.TabIndex = 0;
            this.btnStop.Text = "Stop/Close";
            this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
            // 
            // lblTimer
            // 
            this.lblTimer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lblTimer.Font = new System.Drawing.Font("Verdana", 32.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblTimer.Location = new System.Drawing.Point(0, 0);
            this.lblTimer.Name = "lblTimer";
            this.lblTimer.Size = new System.Drawing.Size(184, 80);
            this.lblTimer.TabIndex = 1;
            this.lblTimer.Text = "00:00";
            this.lblTimer.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.lblTimer.DoubleClick += new System.EventHandler(this.lblTimer_DoubleClick);
            // 
            // tmrSeconds
            // 
            this.tmrSeconds.Interval = 1000;
            this.tmrSeconds.Tick += new System.EventHandler(this.tmrSeconds_Tick);
            // 
            // btnReset
            // 
            this.btnReset.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.btnReset.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnReset.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnReset.Location = new System.Drawing.Point(0, 80);
            this.btnReset.Name = "btnReset";
            this.btnReset.Size = new System.Drawing.Size(184, 24);
            this.btnReset.TabIndex = 3;
            this.btnReset.Text = "Reset/Start";
            this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
            // 
            // mniReset
            // 
            this.mniReset.Index = 2;
            this.mniReset.Text = "Reset/Start";
            this.mniReset.Click += new System.EventHandler(this.mniReset_Click);
            // 
            // mniStop
            // 
            this.mniStop.Index = 3;
            this.mniStop.Text = "Stop/Close";
            this.mniStop.Click += new System.EventHandler(this.mniStop_Click);
            // 
            // ctxMenuTimer
            // 
            this.ctxMenuTimer.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1,
            this.menuItem2,
            this.mniReset,
            this.mniStop});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemConfirmReset});
            this.menuItem1.Text = "Reset position/size";
            // 
            // menuItemConfirmReset
            // 
            this.menuItemConfirmReset.Index = 0;
            this.menuItemConfirmReset.Text = "Confirm";
            this.menuItemConfirmReset.Click += new System.EventHandler(this.menuItemConfirmReset_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.Text = "-";
            // 
            // frmTimerDisplay
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(184, 128);
            this.ControlBox = false;
            this.Controls.Add(this.lblTimer);
            this.Controls.Add(this.btnReset);
            this.Controls.Add(this.btnStop);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MinimumSize = new System.Drawing.Size(180, 120);
            this.Name = "frmTimerDisplay";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Closed += new System.EventHandler(this.frmTimerDisplay_Closed);
            this.Resize += new System.EventHandler(this.frmTimerDisplay_Resize);
            this.ResumeLayout(false);

		}
		#endregion

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			this.Hide();
			m_instance.Show();
			m_instance.SetMainContextMenu();
            m_instance.Activate();
		}

		public void SetMinutes(int min)
		{
			this.m_minutes = min;
            this.Text = string.Format("{0} minute(s) countdown", min);
		}

		public void SetFontColor(Color clr)
		{
			lblTimer.ForeColor = clr;
			btnStop.ForeColor = clr;
			btnReset.ForeColor = clr;
			m_fontColor = clr;
		}

		public void SetBackColor(Color clr)
		{
			lblTimer.BackColor = clr;
			if(clr.IsKnownColor)
				this.BackColor = clr;
			else
				this.BackColor = Color.FromKnownColor(KnownColor.Control);
		}

		public void SetBlinkColor(Color clr)
		{
			m_highlightColor = clr;
		}

		public void SetAlwaysOnTop(bool value)
		{
			this.TopMost = value;
		}

        public void ResetLocationAndSize()
        {
            this.WindowState = FormWindowState.Normal;
            this.Location = new Point(0, 0);
            this.ClientSize = new Size(184, 128);
        }

		public bool GetAlwaysOnTop()
		{
			return this.TopMost;
		}

		public ContextMenu GetTimerContext()
		{
			return ctxMenuTimer;
		}

		public void StartCount()
		{
			// Init label
			lblTimer.Text = this.m_minutes + ":" + "00";
			this.m_seconds = 0;

			// Activation des timers
			tmrSeconds.Enabled = true;
		}

		private void frmTimerDisplay_Closed(object sender, System.EventArgs e)
		{
			tmrSeconds.Enabled = false;
			lblTimer.ForeColor = Color.Black;
			this.Hide();
			this.m_instance.Show();
		}

		private void tmrSeconds_Tick(object sender, System.EventArgs e)
		{
			// Si compteur termin
			if(this.m_seconds == 0 && this.m_minutes == 0)
			{
				// Clignotement label en rouge
				if(lblTimer.ForeColor == m_fontColor)
					lblTimer.ForeColor = m_highlightColor;
				else
					lblTimer.ForeColor = m_fontColor;
			}
			else
			{
				if(this.m_seconds == 0)
				{
					// Decrementation minutes et secondes
					this.m_minutes--;
					this.m_seconds = 59;
				}
				else
				{
					// Decrementation secondes
					this.m_seconds--;
				}
			}

			string m_displaySeconds = "";
			if(this.m_seconds < 10)
				m_displaySeconds = "0";

			// Mise a jour affichage
			lblTimer.Text = this.m_minutes + ":" + m_displaySeconds + this.m_seconds;
		}

		private void cbxHideBorders_Click(object sender, System.EventArgs e)
		{
			// Cache les bordures de la fenetres
			if(this.FormBorderStyle != FormBorderStyle.None)
			{
				this.FormBorderStyle = FormBorderStyle.None;
			}
			else
			{
				this.FormBorderStyle = FormBorderStyle.Sizable;
			}
		}

		private void btnReset_Click(object sender, System.EventArgs e)
		{
			lblTimer.ForeColor = m_fontColor;
			SetMinutes(m_instance.GetStartMinutes());
			StartCount();
		}
		
		private void lblTimer_DoubleClick(object sender, System.EventArgs e)
		{
			// Cache les bordures de la fenetres
			if(this.FormBorderStyle != FormBorderStyle.None)
			{
				m_isResizable = false;
				this.FormBorderStyle = FormBorderStyle.None;
			}
			else
			{
				m_isResizable = true;
				this.FormBorderStyle = FormBorderStyle.SizableToolWindow;
			}
		}

		private void frmTimerDisplay_Resize(object sender, System.EventArgs e)
		{
            if (m_isResizable)
            {
                int currentWidth = this.Size.Width;
                int currentHeight = this.Size.Height;
                float ratio = 1.5f;

                // Calcul des ratios
                int calculatedWidth = 0;
                int calculatedHeight = 0;

                calculatedWidth = (int)Math.Floor(currentHeight * ratio);
                calculatedHeight = (int)Math.Floor(currentWidth / ratio);

                this.Size = new Size(currentWidth, calculatedHeight);

                // Adapation taille police  la fenetre
                SetTimerFontSize();
            }
		}

		public void SetSizable()
		{
			m_isResizable = true;
		}

		public void SetTimerFontSize()
		{
			int currentWidth = this.Size.Width;
			float increasedRatio = currentWidth / 150;
			Font resizedFont = new Font("Verdana", 28*increasedRatio);
			lblTimer.Font = resizedFont;

            Debug.WriteLine("Ratio : " + increasedRatio.ToString());
		}

		private void mniReset_Click(object sender, System.EventArgs e)
		{
			btnReset_Click(sender, null);
		}

		private void mniStop_Click(object sender, System.EventArgs e)
		{
			btnStop_Click(sender, null);
		}

        private void menuItemConfirmReset_Click(object sender, EventArgs e)
        {
            ResetLocationAndSize();
            this.Activate();
        }
	}
}
